<?php
	$func = rex_request('func', 'string');

	if ($func == '') {
		$list = rex_list::factory("SELECT `id`, `name`, `mediaquery` FROM `".rex::getTablePrefix()."media_manager_plus_breakpoints` ORDER BY `prio` ASC");
		$list->addTableAttribute('class', 'table-striped');
		$list->setNoRowsMessage($this->i18n('breakpoints_norowsmessage'));
		
		// icon column
		$thIcon = '<a href="'.$list->getUrl(['func' => 'add']).'"><i class="rex-icon rex-icon-add-action"></i></a>';
		$tdIcon = '<i class="rex-icon fa-file-text-o"></i>';
		$list->addColumn($thIcon, $tdIcon, 0, ['<th class="rex-table-icon">###VALUE###</th>', '<td class="rex-table-icon">###VALUE###</td>']);
		$list->setColumnParams($thIcon, ['func' => 'edit', 'id' => '###id###']);
		
		$list->setColumnLabel('name', $this->i18n('breakpoints_column_name'));
		$list->setColumnLabel('mediaquery', $this->i18n('breakpoints_column_mediaquery'));
		
		$list->setColumnParams('name', ['id' => '###id###', 'func' => 'edit']);
		
		$list->removeColumn('id');
		
		$content = $list->get();
		
		$fragment = new rex_fragment();
		$fragment->setVar('content', $content, false);
		$content = $fragment->parse('core/page/section.php');
		
		echo $content;
	} else if ($func == 'add' || $func == 'edit') {
		$id = rex_request('id', 'int');

        $form = rex_form::factory(rex::getTablePrefix().'media_manager_plus_breakpoints', '', 'id='.$id);

		if ($func == 'edit') {
			$formLabel = $this->i18n('breakpoints_formcaption_edit');
		} elseif ($func == 'add') {
			$formLabel = $this->i18n('breakpoints_formcaption_add');
            $form->setEditMode(false);
		}

        $field = $form->addPrioField('prio');
        $field->setLabel($this->i18n('breakpoints_label_prio'));
        $field->setAttribute('class', 'selectpicker form-control');
        $field->setLabelField('name');
		
		//Start - add name-field
			$field = $form->addTextField('name', null, ($func == 'edit' ? ['readonly' => true]: []));
			$field->setLabel($this->i18n('breakpoints_label_name'));
		//End - add name-field
		
		//Start - add mediaquery-field
			$field = $form->addTextField('mediaquery');
			$field->setLabel($this->i18n('breakpoints_label_mediaquery'));
		//End - add mediaquery-field
		
		if ($func == 'edit') {
			$form->addParam('id', $id);
		}
		
		$content = $form->get();
		
		$fragment = new rex_fragment();
		$fragment->setVar('class', 'edit', false);
		$fragment->setVar('title', $formLabel, false);
		$fragment->setVar('body', $content, false);
		$content = $fragment->parse('core/page/section.php');
		
		echo $content;
	}
?>